; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	rcall ZEILE1		; ZEILE1
	LDS temp1,(adr_TASTE)
	tst temp1
	breq MENUE_RUN
	rcall LCD_CLEAR
;-------------------------------------------------------------------------------
MENUE_p:
	LDS temp1,(adr_TASTE)
	cpi temp1,(TASTE_MENUE_PLUS)
	brne MENUE_m
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_m:
	cpi temp1,(TASTE_MENUE_MINUS)
	brne MENUE_RUN
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_RUN
	dec temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL, LOW(MENUE_SPRUNGMARKE)	; Z		
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
;	LSL temp	; x2, wegen "jmp (2 Words)"	
	add ZL,temp
	adc ZH,NULL
	IJMP	; SPRUNG nach Z
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	rjmp MENUE_HAUPT
	rjmp MENUE_AUDIO_DIREKT
	rjmp MENUE_AUDIO_PLAY
	rjmp MENUE_AUDIO_AUFNAHME
;	rjmp MENUE_SERIELL
	rjmp MENUE_TEST_READ
	rjmp MENUE_SEKTOR_NULL_READ
	rjmp MENUE_SEKTOR_READ
	rjmp MENUE_SD_INFO1
	rjmp MENUE_SD_REGISTER_CID
	rjmp MENUE_SD_REGISTER_CSD
	rjmp MENUE_SD_REGISTER_OCR
	rjmp MENUE_SYSTEM
	rjmp MENUE_WARNUNG
	rjmp MENUE_SD_FORMAT
	rjmp ANZEIGE_BEGRUESSUNG
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_BAUSTELLE
	STS(adr_MENUE),NULL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	rcall TEXT_BAUSTELLE
	LDS temp1,(adr_MENUE)
	rcall ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WARNUNG:
	rcall ZEILE2
	rcall TEXT_WARNUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_HAUPT:
	rcall ANZEIGE_ZEIT
	rcall ASCII_SPACE4
	rcall ANZEIGE_DATUM
;-------------------------------------------------------------------------------
	rcall ZEILE2
	LDS temp1,(adr_SD_CAPACITY_MB0)
	LDS temp2,(adr_SD_CAPACITY_MB1)
	LDS temp3,(adr_SD_CAPACITY_MB2)
	LDS temp4,(adr_SD_CAPACITY_MB3)
	rcall ZAHL_TEMP1_2_3_4
	rcall TEXT_MB
;-------------------------------------------------------------------------------
	rcall ZEILE3
	LDS temp1,(adr_SD_SEKTOR_MAX0)
	LDS temp2,(adr_SD_SEKTOR_MAX1)
	LDS temp3,(adr_SD_SEKTOR_MAX2)
	LDS temp4,(adr_SD_SEKTOR_MAX3)
	rcall ZAHL_TEMP1_2_3_4
;-------------------------------------------------------------------------------
	rcall ZEILE4
	LDS temp,(adr_SD_PNM1)			; Produkt NAME PNM
	rcall LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM2)
	rcall LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM3)
	rcall LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM4)
	rcall LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM5)
	rcall LCD_DATA_TEMP
	rcall ASCII_SPACE

	rcall ASCII_2						; Jahr
	rcall ASCII_0
	LDS temp1,(adr_SD_MDT)
	rcall ZAHL2_TEMP1
	rcall ASCII_SPACE

	LDS temp1,(adr_SD_PSN0)
	rcall HEX_TEMP1
	LDS temp1,(adr_SD_PSN1)
	rcall HEX_TEMP1
	LDS temp1,(adr_SD_PSN2)
	rcall HEX_TEMP1
	LDS temp1,(adr_SD_PSN3)
	rcall HEX_TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_AUDIO_DIREKT:
	rcall TEXT_AUDIO
	rcall TEXT_DIREKT
	rcall TASTE_PLUS_C
	brcs MENUE_AUDIO_DIREKT_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_AUDIO_DIREKT_RUN:
	rjmp AUDIO_DIREKT
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_AUDIO_PLAY:
	rcall TEXT_AUDIO
	rcall TEXT_PLAY
	rcall TASTE_PLUS_C
	brcs MENUE_AUDIO_PLAY_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_AUDIO_PLAY_RUN:
	rjmp AUDIO_PLAY
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_AUDIO_AUFNAHME:
	rcall TEXT_AUDIO
	rcall TEXT_AUFNAHME
	rcall TASTE_PLUS_C
	brcs MENUE_AUDIO_AUFNAHME_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_AUDIO_AUFNAHME_RUN:
	rjmp AUDIO_AUFNAHME
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_FORMAT:
	rcall TEXT_SD
	rcall TEXT_FORMAT
	rcall TASTE_PLUS_C
	brcs MENUE_SD_FORMAT_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SD_FORMAT_RUN:
	rcall SD_DATA_CLEAR
	rcall SEKTOR_NULL
;-------------------------------------------------------------------------------
MENUE_SD_FORMAT_s:
	rcall SD_SEKTOR_WRITE
	rcall SEKTOR_PLUS_EINS
	tst SEKTOR2
	brne MENUE_SD_FORMAT_EXIT
	tst SEKTOR0
	brne MENUE_SD_FORMAT_s
	rcall ZEILE3
	rcall ANZEIGE_SEKTOR_NUMMER_KURZ
	rcall TASTEN_AKTIVIEREN
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	rjmp MENUE_SD_FORMAT_EXIT
	rjmp MENUE_SD_FORMAT_s
;-------------------------------------------------------------------------------
MENUE_SD_FORMAT_EXIT:
	rcall ZEILE4
	rcall TEXT_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SERIELL:
	LDS temp, (adr_SERIELL_DATA+0)
	rcall LCD_DATA_TEMP
	rcall ASCII_SPACE
	LDS temp1,(adr_SERIELL_DATA+0)
	rcall ZAHL_TEMP1
;-------------------------------------------------------------------------------
	rcall ZEILE2
	LDS temp1,(adr_SERIELL_DATA+1)
	rcall ZAHL_TEMP1	
	LDS temp1,(adr_SERIELL_DATA+2)
	rcall ZAHL_TEMP1	
	LDS temp1,(adr_SERIELL_DATA+3)
	rcall ZAHL_TEMP1	
	LDS temp1,(adr_SERIELL_DATA+4)
	rcall ZAHL_TEMP1	
;-------------------------------------------------------------------------------
	rcall ZEILE3
	LDS temp, (adr_SERIELL_DATA+5)
	rcall LCD_DATA_TEMP
	rcall ASCII_SPACE
	LDS temp1,(adr_SERIELL_DATA+5)
	rcall ZAHL_TEMP1
;-------------------------------------------------------------------------------
	rcall ZEILE4
	LDS temp1,(adr_SERIELL_RESET)
	rcall ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_INFO1:
	rcall ANZEIGE_SD_INFO1
	rcall WAIT_100ms
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_REGISTER_CID:
	rcall TEXT_SD
	rcall TEXT_REGISTER
	rcall TEXT_CID
	rcall SD_CID_READ
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	rcall ZEILE2
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE3
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE4
	rjmp ANZEIGE_DATA_ZEILE_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_REGISTER_CSD:
	rcall TEXT_SD
	rcall TEXT_REGISTER
	rcall TEXT_CSD
	rcall SD_CSD_READ
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	rcall ZEILE2
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE3
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE4
	rjmp ANZEIGE_DATA_ZEILE_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_REGISTER_OCR:
	rcall TEXT_SD
	rcall TEXT_REGISTER
	rcall TEXT_OCR
	rcall SD_OCR_READ
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	rcall ZEILE2
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE3
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE4
	rjmp ANZEIGE_DATA_ZEILE_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SEKTOR_NULL_READ:
	rcall TEXT_SEKTOR
	rcall TEXT_NULL
	rcall TEXT_READ
	rcall TASTE_PLUS_C
	brcs MENUE_SNR_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SNR_RUN:
	rcall ZEILE1
	rcall SEKTOR_NULL
	rcall SD_SEKTOR_READ
	rcall ANZEIGE_SD_DATA
	rjmp TASTEN_WAIT
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SEKTOR_READ:
	rcall TEXT_SEKTOR
	rcall ANZEIGE_SEKTOR_NUMMER_KURZ
	rcall TEXT_READ
	rcall TASTE_PLUS_C
	brcs MENUE_SR_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SR_RUN:
	rcall SD_SEKTOR_READ
	rcall SEKTOR_PLUS_EINS
	rcall ANZEIGE_SD_DATA
	rjmp TASTEN_WAIT
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TEST_READ:
	rcall TEXT_TEST
	rcall TEXT_READ
	rcall TASTE_PLUS_C
	brcs MENUE_TEST_READ_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TEST_READ_RUN:
	rcall SEKTOR_NULL	; NULL		
MENUE_TEST_READ_s:
	rcall SD_SEKTOR_READ
	rcall SEKTOR_PLUS_EINS
	tst SEKTOR0
	brne MENUE_TEST_READ_s	
	rcall ZEILE3
	rcall ANZEIGE_SEKTOR_NUMMER_KURZ
	rcall TASTEN_AKTIVIEREN
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	rjmp MENUE_TEST_READ_EXIT
	tst SEKTOR2
	breq MENUE_TEST_READ_s
;-------------------------------------------------------------------------------
MENUE_TEST_READ_EXIT:
	rcall ZEILE4
	rcall TEXT_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SYSTEM:
	rcall TEXT_SYSTEM
	rcall ZEILE2

	ldi temp1,LOW (RAMEND)
	ldi temp2,HIGH(RAMEND)
	ldi temp3,LOW (SRAM_START)
	ldi temp4,HIGH(SRAM_START)
	sub temp1,temp3
	sbc temp2,temp4
	rcall ZAHL_TEMP1_2



ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




