; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_AKTIVIEREN:
	cbi (TASTE_A_DDR),(TASTE_A_PIN_NR)	; auf Eingang					
	cbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
	cbi (TASTE_C_DDR),(TASTE_C_PIN_NR)
	cbi (TASTE_D_DDR),(TASTE_D_PIN_NR)
;-------------------------------------------------------------------------------
	sbi (TASTE_A_PORT),(TASTE_A_PIN_NR)	; Pull-Up on					
	sbi (TASTE_B_PORT),(TASTE_B_PIN_NR)
	sbi (TASTE_C_PORT),(TASTE_C_PIN_NR)
	sbi (TASTE_D_PORT),(TASTE_D_PIN_NR)
	rcall WAIT_10us
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_ABFRAGE:
	LDS temp,(adr_TASTE)
	tst temp
	breq TASTEN_ABFRAGE_RUN
	rcall WAIT_200ms
;-------------------------------------------------------------------------------
TASTEN_ABFRAGE_RUN:
	rcall TASTEN_AKTIVIEREN
	clr temp
	ldi temp9,255							; Schleife
TASTEN_ABFRAGE_s:
	; Taste "A"gedrckt ?		
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(1)
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(2)
	; Taste "C"gedrckt ?		
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(4)
	; Taste "D"gedrckt ?		
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(8)
;-------------------------------------------------------------------------------
	STS(adr_TASTE),temp
	tst temp
	brne TASTEN_ABFRAGE_w
;-------------------------------------------------------------------------------
	rcall WAIT_100us
	dec temp9							; Schleife
	brne TASTEN_ABFRAGE_s
;-------------------------------------------------------------------------------
TASTEN_ABFRAGE_w:
	sbi (TASTE_A_DDR),(TASTE_A_PIN_NR)	; auf AUSGANG					
	sbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
	sbi (TASTE_C_DDR),(TASTE_C_PIN_NR)
	sbi (TASTE_D_DDR),(TASTE_D_PIN_NR)
;-------------------------------------------------------------------------------
	cpi temp,(TASTE_PLUS)+(TASTE_MINUS); RESET ?
	breq TASTE_RESET
	tst temp								; TASTE ?	
	breq TASTE_NIX
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
	rcall BEEP_TASTE
	rcall LCD_CLEAR
;-------------------------------------------------------------------------------
TASTE_NIX:
	ret
;-------------------------------------------------------------------------------
TASTE_RESET:
	CLI											; INTERRUPTS sperren	
	rcall LCD_CLEAR
	LED_GRUEN_ON
	LED_GELB_ON
	LED_ROT_ON
	rcall TEXT_RESET
	rcall WAIT_1s	
	rjmp RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
; warte auf Taste																
TASTEN_WAIT:
	rcall TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq TASTEN_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTE_PLUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_PLUS)
	brne TASTE_NO
	sec 	;Set Carry		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTE_MINUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MINUS)
	brne TASTE_NO
	sec 	;Set Carry		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTE_MENUE_PLUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MENUE_PLUS)
	brne TASTE_NO
	sec 	;Set Carry		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTE_NO:
	clc		; Clear Carry	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


















