; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BEGRUESSUNG:
	rcall ZEILE1	; ZEILE1	
	ldi ZH, high(TEXT_BEGRUESSUNG_11*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_11*2)
	rcall ANZEIGE_TEXT_Z
	rcall ZEILE2	; ZEILE2	
	ldi ZH, high(TEXT_BEGRUESSUNG_12*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_12*2)
	rcall ANZEIGE_TEXT_Z
	rcall ZEILE3	; ZEILE3	
	ldi ZH, high(TEXT_BEGRUESSUNG_13*2)	; TEXT	
	ldi ZL,  low(TEXT_BEGRUESSUNG_13*2)
	rcall ANZEIGE_TEXT_Z
	rcall ZEILE4	; ZEILE4	
	ldi ZH, high(TEXT_BEGRUESSUNG_14*2)	; TEXT	
	ldi ZL,  low(TEXT_BEGRUESSUNG_14*2)
	rcall ANZEIGE_TEXT_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR:
	rcall WAIT_500ms
	rcall LCD_CLEAR
	rcall TEXT_ERROR
	mov temp1,ERROR
	rcall HEX_TEMP1
;-------------------------------------------------------------------------------	
	rcall ZEILE2
	rcall ANZEIGE_SEKTOR_NUMMER_KURZ
	rjmp WAIT_1s	
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ZEIT:
	LDS temp1,(adr_hh)
	rcall ZAHL2_TEMP1
	rcall ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_mm)
	rcall ZAHL2_TEMP1
	rcall ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ss)
	rjmp ZAHL2_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_DATUM:
	LDS temp1,(adr_TAG)
	rcall ZAHL2_TEMP1
	rcall ASCII_PUNKT
	LDS temp1,(adr_MONAT)
	rcall ZAHL2_TEMP1
	rcall ASCII_PUNKT
	LDS temp1,(adr_JAHR)
	rjmp ZAHL2_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STOPUHR:
	LDS temp1,(adr_SU_hh)
	rcall ZAHL2_TEMP1
	rcall ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_SU_mm)
	rcall ZAHL2_TEMP1
	rcall ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_SU_ss)
	rcall ZAHL2_TEMP1
	rcall ASCII_PUNKT
	LDS temp1,(adr_SU_ss10)
	rjmp ZAHL2_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SD_DATA:
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	rcall ZEILE1
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE2
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE3
	rcall ANZEIGE_DATA_ZEILE_Z
	rcall ZEILE4
	rjmp ANZEIGE_DATA_ZEILE_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SEKTOR_NUMMER_KURZ:
	mov temp1,SEKTOR0
	mov temp2,SEKTOR1
	mov temp3,SEKTOR2
	mov temp4,SEKTOR3
	rjmp ZAHL_TEMP1_2_3_4
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_DATA_ZEILE_Z:
	ldi temp9,6
ANZEIGE_DATA_Z_s:
	LD temp1,Z+
	rcall HEX_TEMP1
	rcall ASCII_SPACE
	dec temp9
	brne ANZEIGE_DATA_Z_s
	LD temp1,Z+
	rjmp HEX_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SD_INFO1:
	rcall TEXT_SD
	rcall TEXT_INFO
	rcall SD_CID_READ				; REGISTER CID	 (card identification)
	rcall SD_CSD_CALC				; REGISTER CSD	
	rcall SD_OCR_READ				; REGISTER OCR	
	rcall ASCII_SPACE4
	LDS temp,(adr_SD_SDHC_AKTIV)	
	tst temp
	breq SD_INFO_w
	rcall TEXT_SDHC
SD_INFO_w:
;-------------------------------------------------------------------------------
	rcall ZEILE2

	LDS temp1,(adr_SD_CAPACITY_MB0)
	LDS temp2,(adr_SD_CAPACITY_MB1)
	LDS temp3,(adr_SD_CAPACITY_MB2)
	LDS temp4,(adr_SD_CAPACITY_MB3)
	rcall ZAHL_TEMP1_2_3_4
	rcall TEXT_MB
;-------------------------------------------------------------------------------
	rcall ZEILE3
	LDS temp1,(adr_SD_SEKTOR_MAX0)
	LDS temp2,(adr_SD_SEKTOR_MAX1)
	LDS temp3,(adr_SD_SEKTOR_MAX2)
	LDS temp4,(adr_SD_SEKTOR_MAX3)
	rcall ZAHL_TEMP1_2_3_4
	rcall TEXT_SEKTOREN
;-------------------------------------------------------------------------------
	rcall ZEILE4

	LDS temp,(adr_SD_PNM1)			; Produkt NAME PNM
	rcall LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM2)
	rcall LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM3)
	rcall LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM4)
	rcall LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM5)
	rcall LCD_DATA_TEMP
	rcall ASCII_SPACE

	rcall ASCII_2						; Jahr
	rcall ASCII_0
	LDS temp1,(adr_SD_MDT)
	rcall ZAHL2_TEMP1
	rcall ASCII_SPACE

	LDS temp1,(adr_SD_PSN0)
	rcall HEX_TEMP1
	LDS temp1,(adr_SD_PSN1)
	rcall HEX_TEMP1
	LDS temp1,(adr_SD_PSN2)
	rcall HEX_TEMP1
	LDS temp1,(adr_SD_PSN3)
	rcall HEX_TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

