; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B: "6"																		
ZAHL1_TEMP1:
	cpi temp1,9+1	; berlauf	
	brlo ZAHL1_TEMP1_RUN
	rjmp ASCII_MINUS
;-------------------------------------------------------------------------------
ZAHL1_TEMP1_RUN:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	mov temp, temp1			; 1.ZIFFER (1-er Stelle)	
	rjmp LCD_DATA_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B: "06"																		
ZAHL2_TEMP1:
	cpi temp1,99+1	; berlauf	
	brlo ZAHL2_TEMP1_RUN
	rcall ASCII_MINUS
	rjmp  ASCII_MINUS
;-------------------------------------------------------------------------------
ZAHL2_TEMP1_RUN:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	mov temp, temp2			; 2.
	rcall LCD_DATA_TEMP	
	mov temp, temp1			; 1.ZIFFER (1-er Stelle)	
	rjmp LCD_DATA_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_TEMP1:
	clr temp2
ZAHL_TEMP1_2:
	clr temp3
ZAHL_TEMP1_2_3:
	clr temp4
ZAHL_TEMP1_2_3_4:
	rjmp ZAHL_FORMATIERT
; ##############################################################################
ZAHL_TEMP1_2_3_4_FIX:
 	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	rjmp ZIFFERN_10
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_FORMATIERT:
 	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	cpi temp,'0'
	brne ZIFFERN_10
	cpi temp9,'0'
	brne ZIFFERN_9
	cpi temp8,'0'
	brne ZIFFERN_8
	cpi temp7,'0'
	brne ZIFFERN_7
	cpi temp6,'0'
	brne ZIFFERN_6
	cpi temp5,'0'
	brne ZIFFERN_5
	cpi temp4,'0'
	brne ZIFFERN_4
	cpi temp3,'0'
	brne ZIFFERN_3
	cpi temp2,'0'
	brne ZIFFERN_2
	rjmp ZIFFERN_1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1...TEMP9 (temp)												
ZIFFERN_10:
	; temp !
	rcall LCD_DATA_TEMP		;10.
	rcall ASCII_PUNKT				;'.'
ZIFFERN_9:
	mov temp, temp9			; 9.
	rcall LCD_DATA_TEMP	
ZIFFERN_8:
	mov temp, temp8			; 8.
	rcall LCD_DATA_TEMP	
ZIFFERN_7:
	mov temp, temp7			; 7.
	rcall LCD_DATA_TEMP	
	rcall ASCII_PUNKT				;'.'
ZIFFERN_6:
	mov temp, temp6			; 6.
	rcall LCD_DATA_TEMP	
ZIFFERN_5:
	mov temp, temp5			; 5.
	rcall LCD_DATA_TEMP	
ZIFFERN_4:
	mov temp, temp4			; 4.
	rcall LCD_DATA_TEMP
	rcall ASCII_PUNKT				;'.'
ZIFFERN_3:
	mov temp, temp3			; 3.
	rcall LCD_DATA_TEMP	
ZIFFERN_2:
	mov temp, temp2			; 2.
	rcall LCD_DATA_TEMP	
ZIFFERN_1:
	mov temp, temp1			; 1.ZIFFER (1-er Stelle)	
	rcall LCD_DATA_TEMP
	rjmp ASCII_SPACE			;' '
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																	
; OUT: (z.B."FF") 																
HEX_TEMP1:
	; SICHERUNGSKOPIE						
	push temp
	push temp1
	; oberes NIBBLE bearbeiten				
	mov temp,temp1	
	swap temp						; NIBBLES tausch	
	rcall LCD_HEX8_UMWANDLUNG	; INP/OUT: temp		
	rcall LCD_DATA_TEMP					; ANZEIGE			
	; unteres NIBBLE bearbeiten				
	mov temp,temp1	
	rcall LCD_HEX8_UMWANDLUNG	; INP/OUT: temp		
	rcall LCD_DATA_TEMP					; ANZEIGE			
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp1
	pop temp
	ret
;-------------------------------------------------------------------------------
LCD_HEX8_UMWANDLUNG:
	; BITMUSTER	
	andi temp,0b00001111
	; vergleich	
	cpi temp,10
	brsh LCD_HEX8_UMWANDLUNG_A_F
LCD_HEX8_UMWANDLUNG_0_9:
	subi temp,-48
	ret
LCD_HEX8_UMWANDLUNG_A_F:
	subi temp,-48-7
	ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; STAND: 09.12.2011															
;																			
;	Value: 0...	9.999.999.999												
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		     1-er Stelle)								
;			temp2	(		    10-er Stelle)								
;			temp3	(          100-er Stelle)								
;			temp4	(        1.000-er Stelle)								
;			temp5	(       10.000-er Stelle)								
;			temp6	(      100.000-er Stelle)								
;			temp7	(    1.000.000-er Stelle)								
;			temp8	(   10.000.000-er Stelle)								
;			temp9	(  100.000.000-er Stelle)								
;			temp	(1.000.000.000-er Stelle)								
; 																			
FUNKTION_HEX_ASC_32:
;---------------------------------------------------------------------------
	clr temp			
FUNKTION_HEX_ASC_109:	; 1.100.000.000
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNKTION_HEX_ASC_109
	subi temp, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)
;---------------------------------------------------------------------------
	clr temp9			
FUNKTION_HEX_ASC_108:	; 100.000.000
	inc temp9
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNKTION_HEX_ASC_108
	subi temp9, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
;---------------------------------------------------------------------------
	clr temp8
FUNKTION_HEX_ASC_107:	; 10.000.000
	inc temp8
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_107
	subi temp8, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
;---------------------------------------------------------------------------
	clr temp7
FUNKTION_HEX_ASC_106:	; 1.000.000
	inc temp7
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_106
	subi temp7, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
;---------------------------------------------------------------------------
	clr temp6
FUNKTION_HEX_ASC_105:	; 100.000	
	inc temp6
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_105
	subi temp6, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
;---------------------------------------------------------------------------	clr temp
	clr temp5
FUNKTION_HEX_ASC_104:	; 10.000	
	inc temp5
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_104
	subi temp5, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
;---------------------------------------------------------------------------
	clr temp4
FUNKTION_HEX_ASC_103:	; 1.000		
	inc temp4
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_103
	subi temp4, (-48+1)	; HEX->ASC	
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
;---------------------------------------------------------------------------
	clr temp3
FUNKTION_HEX_ASC_102:	; 100		
	inc temp3
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_102
	subi temp3, (-48+1)	; HEX->ASC	
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
;---------------------------------------------------------------------------
	clr temp2
FUNKTION_HEX_ASC_101:	; 10		
	inc temp2
	subi temp1, low  (10)
	brcc FUNKTION_HEX_ASC_101
	subi temp2, (-48+1)	; HEX->ASC	
	subi temp1, low  (-10)
;---------------------------------------------------------------------------
FUNKTION_HEX_ASC_100:	; 1			
	subi temp1, -48		; HEX->ASC	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
